#include "calc_sqrt2_core.h"

#define LONG_UNIT_MAX 1000000000

/**
 * Kvunsigned int^̔z̗vfԂ
 * @param digit vZ錅
 * @return KvȔz̗vf
 */ 
int getNeededMemory(unsigned int digit) {
	int memory;
	/* vf11000000000-1܂ł9i[ */ 
	memory=(digit+9-1)/9;
	/* xlė]T */
	memory+=5;
	return memory; 
}

/**
 * {̑Z
 * @param dest 鐔(ʂ㏑)
 * @param src 
 * @param size {̃TCY
 * @param firstNonZero 鐔̍ŏ0ȊOvf̈ʒu 
 */ 
void addLongInt(unsigned int* dest,const unsigned int* src,int size,int firstNonZero) {
	int i;
	int carry=0;
	for(i=size-1;i>=0;i--) {
		dest[i]+=src[i]+carry;
		carry=dest[i]/LONG_UNIT_MAX;
		dest[i]%=LONG_UNIT_MAX;
		if(carry==0 && i<=firstNonZero)break;
	}
}

/**
 * {̈Z
 * @param dest 鐔(ʂ㏑)
 * @param src 
 * @param size {̃TCY
 * @param firstNonZero ̍ŏ0ȊOvf̈ʒu 
 */ 
void subLongInt(unsigned int* dest,const unsigned int* src,int size,int firstNonZero) {
	int i;
	int carry=0;
	for(i=size-1;i>=0;i--) {
		if(dest[i]<src[i]+carry) {
			dest[i]=LONG_UNIT_MAX+dest[i]-src[i]-carry;
			carry=1;
		} else {
			dest[i]=dest[i]-src[i]-carry;
			carry=0;
		}
		if(carry==0 && i<=firstNonZero)break;
	}
}

/**
 * {~vf̊|Z
 @param dest |鐔(ʂ㏑)
 @param mul 鐔
 @param size {̃TCY
 @param firstNonZero |鐔̍ŏ0ȊOvf̈ʒu
 @return ʂ̐̍ŏ0ȊOvf̈ʒu
 */
int mulLongInt(unsigned int* dest,unsigned int mul,int size,int firstNonZero) {
	unsigned long long carry=0;
	int i;
	int newFirstNonZero=-1;
	for(i=size-1;i>=0;i--) {
		carry=(unsigned long long)dest[i]*mul+carry;
		dest[i]=carry%LONG_UNIT_MAX;
		carry/=LONG_UNIT_MAX;
		if(dest[i]>0)newFirstNonZero=i;
		if(i<=firstNonZero && carry==0)break;
	}
	if(mul==0)newFirstNonZero=size;
	return newFirstNonZero;
}

/**
 * {vf̊Z
 @param dest 鐔(ʂ㏑)
 @param divBy 鐔
 @param size {̃TCY
 @param firstNonZero 鐔̍ŏ0ȊOvf̈ʒu
 @return ʂ̐̍ŏ0ȊOvf̈ʒu
 */
int divLongInt(unsigned int* dest,unsigned int divBy,int size,int firstNonZero) {
	unsigned long long carry=0;
	int i;
	int newFirstNonZero=-1;
	for(i=firstNonZero;i<size;i++) {
		carry=carry*LONG_UNIT_MAX+dest[i];
		dest[i]=(unsigned int)(carry/divBy);
		if(dest[i]!=0 && newFirstNonZero<0)newFirstNonZero=i;
		carry%=divBy;
	}
	if(newFirstNonZero<0)newFirstNonZero=size;
	return newFirstNonZero;
}
